// ***************************************************************************************
// Implementazione delle funzioni documentate o no del Windows piu' altre......
//
//                     Nome            : API_Routine
//                     Creazione       : 1998
//                     Ultima modifica : Gennaio 2001
//                     Autore          : Guadagnini David       
//                     Versione        : 9.1
//
//   Nota:
//        .Le funzioni di accesso diretto all'hardware NON funzionano sotto WinNT/2K
//        .NON includere la unit in un componente che istallerete sotto WinNT/2K
//        .NON istallate la unit tra i componenti sotto WinNT/2K
// ***************************************************************************************
{
 -----------------------------------------------------------------------------------------
 Procedure e funzioni :
 -----------------------------------------------------------------------------------------

 ControllaBeep                    Abilita/Disabilita il cicalino

 SelezionaCartella                Seleziona SOLAMENTE una cartella

 SelezionaCartellaParticolare     Ritorna la path di una cartella particolare

 AddToRecentDocs                  Aggiunge un file alla lista dei documenti recenti

 ClearRecentDocs                  Cancella la lista dei documenti recenti

 SetupComPort                     Setta una porta di comunicazione utilizzando il dialogo di sistema

 ConnettiInRete                   Connette una risorsa dalla rete

 DisconnettiDallaRete             Disconnette una risorsa dalla rete

 FormatDrive                      Formatta un floppy (chiamando il dialogo di sistema)

 APIFiles                         Esegue le operazioni base sui file

 Copia_Con_API                    Copia un file tramite Explorer

 WExec32                          Esegue un programma esterno

 SendLink                         Esegue un Link

 ChiamaApplet_ControlPanel        Richiama un applet del pannello di controllo

 Lista_Seriali_Disponibili        ritorna il numero delle porte trovate

 SystemInformation                Ritornano le informazioni base del sistema

 DetectCPU                        Ritorna il tipo di processore nel sistema

 DetectCPUSTR                     Ritorna il tipo di processore nel sistema in stringa

 SearchForFile                    Ricerca un file in una serie di directory

 CreateTree                       Crea un direttorio multiplo

 PrevDir                          Ritorna la directory precedente a quella passata

 SetPrivilege                     Setta/Dissetta un determinato privilegio (Win NT/2K)

 CambioRisoluzioneMonitor         Cambio risoluzione del monitor

 EnumeraPassword                  Enumera le password contenute nel sistema (Win95/98)

 GetFileDateTime                  Ritorna la data di un determinato file

 CPUSpeed                         Ritorna la velocita' della CPU

 HideShowProcess                  Nasconde/Visualizza un processo (Win 95/98)

 Rigenerazione_SystemTray         Rigenerazione della System Area

 RealDiskSerialID                 Ritorna il numero seriale dell'Hard-Disk

 GetDiskSerialID                  Ritorna il numero seriale dell'Hard-Disk

 GetDiskLabel                     Ritorna l'etichetta di volume dell'Hard-Disk

 GetDiskFatType                   Ritorna il tipo di FAT dell'Hard-Disk

 RefreshDesktop                   Esegue il refresh del desktop (Win 95/98)

 PressButton                      Simula il click su di un pulsante

 SetPriority                      Imposta la priorit del processo corrente

 Disco_Nel_Drive                  Ritorna se in un determinato drive esiste il disco

 Setta_Ora_Di_Sistema             Setta l'ora di sistema

 GetUnitaDiRete                   lista delle unita' di rete attualmente mappate

 RunOnStartup                     Avvio automatico di un'applicazione all'accenzione di Windows

 DeRunOnStartup                   Elimina un'applicazione dalla lista dei processi da eseguire

 WEBDownloadFile                  Esegue il download di un file da internet

 GetConnectedState                Ritorna il tipo di connessione ad Internet attuale

 Versione_Programma               informazioni di versione di un determinato programma

 LongFileNameToShortFileName      Converte un nome di file dal formato esteso a quello DOS 8.3

      **********************************************************************
      ****** Le seguenti funzioni non funzionano sotto Windows NT/2K *******
      **********************************************************************

 OpenIOCTL                        Apertura Virtual Device Driver

 CloseIOCTL                       Chiusura Virtual Device Driver

 IOCTL_CallInt13                  Esegue L'Interrupt 13h

 IOCTL_CallInt21                  Esegue L'Interrupt 21h - Funzioni Da 4400h a 4411h

 IOCTL_CallInt25                  Esegue L'Interrupt 25h - Absolute Disk Read

 IOCTL_CallInt26                  Esegue L'Interrupt 26h - Absolute Disk Write

 HardDiskSerial                   Ritorna il numero seriale dell'Hard-Disk

 HardDiskLabel                    Ritorna L'etichetta di volume dell'Hard-Disk

 HardDiskSysType                  Ritorna Il tipo di file system dell'Hard-Disk

 Sound                            Riproduce su speaker una determinata frequenza

 NoSound                          Smette di riprodurre su speaker una frequenza

 -----------------------------------------------------------------------------------------
 Variabili :
 -----------------------------------------------------------------------------------------
 _IsNT : Boolean                 Identifica se il sistema e' Windows NT/2K od altri
}
unit API_Routine;

interface

Uses
  Windows, Messages, Forms, SysUtils, Ole2, CommDlg, CommCtrl, ShellApi, Registry,
  Classes, WiniNet;

// -----------------------------------------
// Usato per WExec32 e SetPriority
// -----------------------------------------
Type
  TPriority = (tpBassa, tpNormale, tpAlta, tpRealTime);

// -----------------------------------------
// Usati per accesso diretto all'hardware
// NON FUNZIONANO sotto Window NT/2000
// -----------------------------------------
Const
  flgCarry     	= $001;
  flgParity    	= $002;
  flgAuxiliary 	= $004;
  flgZero      	= $008;
  flgSign      	= $010;
  flgTrap      	= $020;
  flgInterrupt 	= $040;
  flgDirection 	= $080;
  flgOverflow  	= $100;

Var
  DIOCError : Dword;

Type
  DIOC_REGISTERS = Record
                     EBX   : Dword;
                     EDX   : Dword;
                     ECX   : Dword;
                     EAX   : Dword;
                     EDI   : Dword;
                     ESI   : Dword;
                     Flags : Dword;
                   End;

// -----------------------------------------
// Usati per SelezionaCartellaParticolare
// -----------------------------------------
Const
  CSIDL_DESKTOP            = $0000;         // Desktop
  CSIDL_PROGRAMS           = $0002;         // Programmi
  CSIDL_CONTROLS           = $0003;         // Controlli
  CSIDL_PRINTERS           = $0004;         // Stampanti
  CSIDL_PERSONAL           = $0005;         // Personali
  CSIDL_FAVORITES          = $0006;         // Preferiti
  CSIDL_STARTUP            = $0007;         // Iniziale
  CSIDL_RECENT             = $0008;         // Recenti
  CSIDL_SENDTO             = $0009;         // Invia a...
  CSIDL_BITBUCKET          = $000A;         // Cestino
  CSIDL_STARTMENU          = $000B;         // Start menu
  CSIDL_DESKTOPDIRECTORY   = $0010;         // Desktop Directory
  CSIDL_DRIVES             = $0011;         // Driver
  CSIDL_NETWORK            = $0012;         // Rete
  CSIDL_NETHOOD            = $0013;         // Risorse di rete
  CSIDL_FONTS              = $0014;         // Font
  CSIDL_TEMPLATES          = $0015;         // Nuovo...

  // --------------------------------------------------
  // Le seguenti sono valide SOLO con Window 98 e 2000
  // --------------------------------------------------
  CSIDL_TEMPINTERNET       = $0020;         // Temporary Internet Files
  CSIDL_COOKIES            = $0021;         // Cookies
  CSIDL_CRONO              = $0022;         // Cronologia

// ------------------------------------
// Usate per Lista_Seriali_Disponibili
// ------------------------------------
Const
    Max_Seriali = 100; // e' molto improbabile avere piu' di 100 seriali

Type
   TPorte_Disponibili  = Array[1..Max_Seriali] Of Byte;

// ----------------------------
// Usata per DetectCPU
// ----------------------------
Type
  TCpuType = (cpu8086, cpu80286, cpu386, cpu486, cpuPentium, cpuxxx1, cpuxxx2, cpuxxx3, cpuxxx4);

// ----------------------------
// Usata per CambioRisoluzione
// ----------------------------
Type
  tpColors = (tp16Colori, tp256Colori, tp65536Colori, tp16MilioniColori, tp4MiliardiColori, tpUnknow);

// -----------------------------------------------------
// Privilegi di Windows NT/2000 usati per SetPrivilege
// -----------------------------------------------------
Const
  SE_CREATE_TOKEN_NAME        = 'SeCreateTokenPrivilege';
  SE_ASSIGNPRIMARYTOKEN_NAME  = 'SeAssignPrimaryTokenPrivilege';
  SE_LOCK_MEMORY_NAME         = 'SeLockMemoryPrivilege';
  SE_INCREASE_QUOTA_NAME      = 'SeIncreaseQuotaPrivilege';
  SE_UNSOLICITED_INPUT_NAME   = 'SeUnsolicitedInputPrivilege';
  SE_MACHINE_ACCOUNT_NAME     = 'SeMachineAccountPrivilege';
  SE_TCB_NAME                 = 'SeTcbPrivilege';
  SE_SECURITY_NAME            = 'SeSecurityPrivilege';
  SE_TAKE_OWNERSHIP_NAME      = 'SeTakeOwnershipPrivilege';
  SE_LOAD_DRIVER_NAME         = 'SeLoadDriverPrivilege';
  SE_SYSTEM_PROFILE_NAME      = 'SeSystemProfilePrivilege';
  SE_SYSTEMTIME_NAME          = 'SeSystemtimePrivilege';
  SE_PROF_SINGLE_PROCESS_NAME = 'SeProfileSingleProcessPrivilege';
  SE_INC_BASE_PRIORITY_NAME   = 'SeIncreaseBasePriorityPrivilege';
  SE_CREATE_PAGEFILE_NAME     = 'SeCreatePagefilePrivilege';
  SE_CREATE_PERMANENT_NAME    = 'SeCreatePermanentPrivilege';
  SE_BACKUP_NAME              = 'SeBackupPrivilege';
  SE_RESTORE_NAME             = 'SeRestorePrivilege';
  SE_SHUTDOWN_NAME            = 'SeShutdownPrivilege';
  SE_DEBUG_NAME               = 'SeDebugPrivilege';
  SE_AUDIT_NAME               = 'SeAuditPrivilege';
  SE_SYSTEM_ENVIRONMENT_NAME  = 'SeSystemEnvironmentPrivilege';
  SE_CHANGE_NOTIFY_NAME       = 'SeChangeNotifyPrivilege';
  SE_REMOTE_SHUTDOWN_NAME     = 'SeRemoteShutdownPrivilege';
  SE_UNDOCK_NAME              = 'SeUndockPrivilege';
  SE_SYNC_AGENT_NAME          = 'SeSyncAgentPrivilege';
  SE_ENABLE_DELEGATION_NAME   = 'SeEnableDelegationPrivilege';

// -----------------------------
// Usato per GetConnectedState
// -----------------------------
Type
  tConnectionType = (tctNone,        // Nessuna connessione
                     tctModem,       // Modem
                     tctLAN,         // Rete
                     tctProxi,       // Proxi server
                     tctModemBusy);  // Modem ma occupato

// ----------------------------------------------------------------------
// Abilita o disabilita il beep del cicalino del computer
// ----------------------------------------------------------------------
Procedure ControllaBeep(Abilita : Boolean);

// ----------------------------------------------------------------------
// Seleziona SOLAMENTE una cartella
//
// Handle  : Handle della finestra chiamante
// _Titolo : Titolo che appare in testa al dialogo di selezione
// _SiRete : Se sono valide anche le path in rete
// ----------------------------------------------------------------------
Function  SelezionaCartella(      Handle  : HWND;
                            Const _Titolo : String;
                                  _SiRete : Boolean) : String;

// ----------------------------------------------------------------------
// Ritorna la path di una cartella particolare
//
// Handle   : Handle della finestra chiamante
// Cartella : Quale cartella selezionare (vedi costanti)
// ----------------------------------------------------------------------
Function SelezionaCartellaParticolare(Handle   : HWND;
                                      Cartella : Integer) : String;

// ----------------------------------------------------------------------
// Aggiunge un file alla lista dei documenti recenti
//
// Cosa : Path + nome file da aggiungere
// ----------------------------------------------------------------------
procedure AddToRecentDocs(Const Cosa : String);

// ----------------------------------------------------------------------
// Cancella la lista dei documenti recenti
// ----------------------------------------------------------------------
procedure ClearRecentDocs;

// ----------------------------------------------------------------------
// Setta una porta di comunicazione utilizzando il dialogo di sistema
//
// Handle : Handle della finestra chiamante
// Porta  : Numero della porta da settare 1/2/3..
// ----------------------------------------------------------------------
Function  SetupComPort(Handle : HWND;
                       Porta  : Byte) : Boolean;

// ----------------------------------------------------------------------
// Connette una risorsa dalla rete
//
// Handle : Handle della finestra chiamante
// Dischi : Se TRUE Connette un disco remoto altrimenti una stampante
// ----------------------------------------------------------------------
procedure ConnettiInRete(Handle : HWND;
                         Dischi : Boolean);

// ----------------------------------------------------------------------
// Disconnette una risorsa dalla rete
//
// Handle : Handle della finestra chiamante
// Dischi : Se TRUE Disconnette un disco remoto altrimenti una stampante
// ----------------------------------------------------------------------
procedure DisconnettiDallaRete(Handle : HWND;
                               Dischi : Boolean);

// ----------------------------------------------------------------------
// Formatta un floppy (chiamando il dialogo di sistema)
//
// Handle  : Handle della finestra chiamante
// DriveA  : Se deve formattare il floppy A o il B
// Sistema : Se dovra' essere un disco di sistema
// ----------------------------------------------------------------------
Function  FormatDrive(Handle  : HWND;
                      DriveA  : Boolean;
                      Sistema : Boolean) : Longint;

// ----------------------------------------------------------------------
// Esegue le operazioni base sui file (deve essere inclusa ShellApi)
//
// Handle       : Handle della finestra chiamante
// Modalita     : Tipo di operazione da eseguire (vedi dopo)
// Partenza     : Nome/Nomi file sorgenti
// Destinazione : Nome/Nomi File destinazione
// Flags        : Flag per l'operazione in corso (vedi dopo)
//
// Modalita
//         .FO_COPY
//         .FO_MOVE,
//         .FO_DELETE
//         .FO_RENAME
//
// Flags :
//         .FOF_MULTIDESTFILES
//          Destinazione multipla
//
//         .FOF_CONFIRMMOUSE
//          Conferma
//
//         .FOF_SILENT
//          Non visualizza nulla
//
//         .FOF_RENAMEONCOLLISION
//          Rinomina automaticamente in caso di file gia' presente
//
//         .FOF_NOCONFIRMATION
//          Nessuna conferma
//
//         .FOF_ALLOWUNDO
//          Si puo' abortire l'operazione
//
//         .FOF_FILESONLY
//          Soltanto file
//
//         .FOF_SIMPLEPROGRESS
//          Non mostra i nomi dei file
//
//         .FOF_NOCONFIRMMKDIR
//          Nessuna conferma della creazione di directory
// ----------------------------------------------------------------------
Function  APIFiles(      Handle       : HWND;
                         Modalita     : Integer;
                   Const Partenza     : String;
                   Const Destinazione : String;
                         Flags        : Integer) : Boolean;

Function  Copia_Con_API(      Handle       : HWND;
                        Const Partenza     : String;
                        Const Destinazione : String) : Boolean;

// ----------------------------------------------------------------------
// Esegue un programma esterno (anche non .EXE [Esempio .HLP, .BMP, ...])
//
// Programma : Eseguibile
// Params    : Parametri aggiuntivi
// Priorita  : Priorita' di esecuzione
// bWait     : Se deve attendere la fine del programma
//             (bWait non funziona sotto Windows NT/2000)
// ----------------------------------------------------------------------
Function  WExec32(Const Programma : String;
                  Const Params    : String;
                        Priorita  : TPriority;
                        bWait     : Boolean) : Boolean;

// ----------------------------------------------------------------------
// Esegue un Link
//
// Il formato deve essere uno dei seguenti:
//
//            mailto:<indirizzo>      : e-mail
//            http://<indirizzo>      : web
//            ftp://<indirizzo>       : ftp
//            news:<indirizzo>        : news-group
//
//  Esempio di <indirizzo>:
//
//             mia-email@sito.com
//             www.link.it
//             192.168.10.40/search/index.html
//             newmail.cam.org
// ----------------------------------------------------------------------
Procedure SendLink(Const Link : String);

// -----------------------------------------------------------------------
// Richiama un applet del pannello di controlli (Es. Selezione Data & Ora)
//
// File_CPL : Nome piu' estenzione dell'applet (ES. TimeDate.Cpl)
// PageNum  : Numero TAB dell'applet (0..n) [-1=Nessuna]
// bWait    : Se deve attendere la fine del programma
//
// Esempio per chiamare l'applet per le impostazioni dello schermo
// alla pagina Aspetto si utilizzera':
//
//     ChiamaApplet_ControlPanel('DESK.CPL', 2, False);
//
// dove '2' e' la pagina da visionare (la terza 0,1,2)
// -----------------------------------------------------------------------
Function ChiamaApplet_ControlPanel(Const File_CPL : String;
                                         PageNum  : Integer;
                                         bWait    : Boolean) : Boolean;

// ----------------------------------------------------------------------
// Porte_Disponibile conterra' l'elenco delle COM presenti e non
// utilizzate (Es. Mouse)
// La funzione ritorna il numero delle porte trovate
// ----------------------------------------------------------------------
Function Lista_Seriali_Disponibili(Var Porte_Disponibili : TPorte_Disponibili) : Byte;

// ---------------------------------------------------------------------
// Ritornano le informazioni base del sistema
//
// Versione        : Versione del S.O. (Es. 4.01)
// BuildID         : Build ID del S.O. (Es. 1024)
// Piattaforma     : Tipo di S.O.      (Es. Windows 95)
// MemoriaFisica   : RAM on board      (in Byte)
// MemoriaVirtuale : Memoria virtuale  (in Byte)
// Utente          : Nome Utente       (dato in installazione)
// Compagnia       : Nome Societa'     (data in installazione)
// NMouseButton    : Numeri di Bottoni Per il Mouse (0=No Mouse)
// ScreenX         : Dimenzione X Dello Schermo (In Pixel)
// ScreenY         : Dimenzione Y Dello Schermo (In Pixel)
// BitxPixel       : Numero di colori (In Bit per Pixel - 8=256 Colori)
// Colors          : Numero di colori nel sistema
// ---------------------------------------------------------------------
procedure SystemInformation(Var Versione         : String;
                            Var BuildID          : Integer;
                            Var Piattaforma      : String;
                            Var MemoriaFisica    : Integer;
                            Var MemoriaVirtuale  : Integer;
                            Var Utente           : String;
                            Var Compagnia        : String;
                            Var NMouseButton     : Integer;
                            Var ScreenX, ScreenY : Integer;
                            Var BitxPixel        : Integer;
                            Var Colors           : tpColors);


// ----------------------------------------------------------------------
// Ritorna il tipo di processore nel sistema
//
// DetectCPU    : Tipo interno
// DetectCPUSTR : In Stringa (Es. 80286)
//
// Non Funziona con Pentium II
// ----------------------------------------------------------------------
Function DetectCPU : TCpuType;
Function DetectCPUSTR : String;

// ----------------------------------------------------------------------
// Ricerca un file in una serie di directory
//
// Percorso    : Percorso ove iniziare la ricerca
// NomeFile    : File da trovare
// PathFounded : Path ove e' situato il file
// ----------------------------------------------------------------------
Function SearchForFile(Const Percorso    : String;
                       Const NomeFile    : String;
                       Var   PathFounded : String) : Boolean;

// ----------------------------------------------------------------------
// Crea un direttorio multiplo
//
// Esempio: C:\Uno\Due\Tre\Fine\
//
// Importante:
//            Se il Direttorio deve essere creato su
//            un percorso diverso dalla directory
//            attuale DEVE SEMPRE iniziare
//            con il nome del drive (Es. 'C:\')
//            altrimenti con il nome della prima
//            directory da creare (ES.'Uno\Due\')
//            Deve SEMPRE terminare con uno slash ('\')
// ----------------------------------------------------------------------
Function CreateTree(Const TreeToCreate : String) : Boolean;

// ----------------------------------------------------------------------
// Ritorna la directory precedente a quella passata
//
// Es.
//    S       -> 'C:\Macchine\Faster\Bt 3000\'
//    Ritorno -> 'C:\Macchine\Faster'
// ----------------------------------------------------------------------
Function  PrevDir(Const S : String) : String;

// ----------------------------------------------------------------------
// Setta/Dissetta un determinato privilegio per Windows NT
//
// PrivilegeName -> Nome del privilegio
//                  Es.:
//                      'SeShutdownPrivilege'
//                      Privilegio per ShoutDown
// Enable        -> Abilitazione o disabilitazione
// Ritorno       -> Se TRUE l'operazione ha esito positivo
// ----------------------------------------------------------------------
Function  SetPrivilege(Const PrivilegeName : String;
                             Enable        : Boolean) : Boolean;

// ----------------------------------------------------------------------
// Cambio risoluzione del monitor
//
// (la risoluzione DEVE essere tra quelle previste dalla scheda)
//
// _Width  : Nuova larghezza
// _Height : Nuova altezza
// _Colors : Nuovo numero di colori
//
// Ritorno -> Se TRUE ha avuto esito positivo
// ----------------------------------------------------------------------
Function CambioRisoluzioneMonitor(_Width  : DWORD;
                                  _Height : DWORD;
                                  _Colors : tpColors) : Boolean;

// ----------------------------------------------------------------------
// Enumera le password contenute nel sistema
//
//  Ritorno     : Lista delle risorse e relative password
//  NumPassword : Numero di Risorse-Password trovate
//
// L'output avr il seguente formato
//
//  'Risorsa <Password>' dove:
//                            Risorsa  : Nome della risorsa
//                            Password : Password legata
// ----------------------------------------------------------------------
Function EnumeraPassword(Var NumPassword : Integer) : TStringList;

// ----------------------------------------------------------------------
// Ritorna la data e l'ora di creazione, ultimo accesso,
// ultima modifica di un determinato file
//
// FileName       : Nome del file
// CreationTime   : Data e ora di creazione
// LastAccessTime : Data e ora dell'ultimo accesso
// LastWriteTime  : Data e ora dell'ultima modifica
// ----------------------------------------------------------------------
Function GetFileDateTime(Const FileName       : String;
                         Var   CreationTime   : TDateTime;
                         Var   LastAccessTime : TDateTime;
                         Var   LastWriteTime  : TDateTime) : Boolean;

// ----------------------------------------------------------------------
// Ritorna la velocita' della CPU in Mhz (+/- 1Mhz)
// ----------------------------------------------------------------------
Function CPUSpeed : Longint;

// ----------------------------------------------------------------------
// Nasconde o Visualizza (nasconde se TOHIDE = TRUE)
// un processo dalla lista dei processi (Pressione CTRL+ALT+CANC)
//
// Non presente in Windows 2000
// ----------------------------------------------------------------------
Procedure HideShowProcess(ToHide : Boolean);

// ----------------------------------------------------------------------
// Rigenerazione della System Area per eliminare il pulsante fantasma
// che a volte appare sulla stessa (bug di Windows 98);
// ----------------------------------------------------------------------
Procedure Rigenerazione_SystemTray;

// ----------------------------------------------------------------------
// Trasforma il numero seriale dell'hard disk in 2 Word esadecimali
// ----------------------------------------------------------------------
Function RealDiskSerialID(SerialNumber : UINT) : String;

// ----------------------------------------------------------------------
// Ritorna il numero seriale dell'Hard-Disk (anche sotto NT)
// ----------------------------------------------------------------------
Function GetDiskSerialID(Disk : Char) : Integer;

// ----------------------------------------------------------------------
// Ritorna l'etichetta di volume dell'Hard-Disk (anche sotto NT)
// ----------------------------------------------------------------------
Function GetDiskLabel(Disk : Char) : String;

// ----------------------------------------------------------------------
// Ritorna il tipo di FAT dell'Hard-Disk (anche sotto NT)
// ----------------------------------------------------------------------
Function GetDiskFatType(Disk : Char) : String;

// ----------------------------------------------------------------------
// Esegue il refresh del desktop (non funziona sotto NT)
// ----------------------------------------------------------------------
Procedure RefreshDesktop;

// ----------------------------------------------------------------------
// Simula il click su di un pulsante
// ----------------------------------------------------------------------
Procedure PressButton(Button : THandle);

// ----------------------------------------------------------------------
// Imposta la priorit del processo corrente
//
// Si puo' scegliere tra una delle seguenti:
//
// HIGH_PRIORITY_CLASS     : Massima possibile
// IDLE_PRIORITY_CLASS     : Minima possibile
// NORMAL_PRIORITY_CLASS   : Normale
// REALTIME_PRIORITY_CLASS : Tempo reale (pericolosa)
// ----------------------------------------------------------------------
Procedure SetPriority(Priorita : TPriority);

// ----------------------------------------------------------------------
// Ritorna se in un determinato drive esiste il disco
// ----------------------------------------------------------------------
Function Disco_Nel_Drive(Disco : Char) : Boolean;

// ----------------------------------------------------------------------
// Setta l'ora di sistema
// ----------------------------------------------------------------------
Function Setta_Ora_Di_Sistema(tDati: TDateTime) : Boolean;

//-----------------------------------------------------------------------
// Ritorna la lista delle unita' di rete attualmente mappate
// sul computer in uso nella forma <DRIVE>:<NOME DI RETE>
//
// Esempio: F:Disco C su server
//-----------------------------------------------------------------------
Function GetUnitaDiRete(Sl : TStrings) : Integer;

// ----------------------------------------------------------------------
// Avvio automatico di un'applicazione all'accenzione di Windows
//
// Dove:
//      Programma   : Nome Programma/Applicazione
//      CommandLine : Linea di comando
//      RunOnce     : Se deve essere eseguito solo alla prossima
//                    accenzione e poi basta
// ----------------------------------------------------------------------
Procedure RunOnStartup(Const Programma   : String;
                       Const CommandLine : String;
                             RunOnce     : Boolean);

// ----------------------------------------------------------------------
// Elimina un'applicazione dalla lista dei processi da eseguire
// all'accenzione di Windows
//
// Dove:
//      Programma   : Nome Programma/Applicazione
//      RunOnce     : Se deve essere eseguito solo alla prossima
//                    accenzione e poi basta
// ----------------------------------------------------------------------
Procedure DeRunOnStartup(Const Programma : String;
                               RunOnce   : Boolean);

// ----------------------------------------------------------------------
// Esegue il download di un file da internet
//
// Dove:
//      URL       : Indirizzo internet + nome file
//      LocalName : Nome file piu' path locale ove salvarlo
//
// Se per esempio devo scaricare dall'indirizzo http://www.pippo.com/docs
// il file a1.doc e salvarlo in C:\Temp la chiamata sara':
//
// WEBDownloadFile('http://www.pippo.com/docs/a1.doc', 'C:\Temp\a1.doc');
// ----------------------------------------------------------------------
Function  WEBDownloadFile(Const URL       : String;
                          Const LocalName : String) : Boolean;

// ----------------------------------------------------------------------
// Ritorna il tipo di connessione ad Internet attuale
// ----------------------------------------------------------------------
Function GetConnectedState : tConnectionType;

// ----------------------------------------------------------------------
// Ritornano le informazioni di versione di un determinato programma
// Se si vogliono le informazioni del programma stesso basta passare
// come nome file la funzione ParamStr(0)
// ----------------------------------------------------------------------
Function Versione_Programma(Const FileName         : String;
                            Var   StrucVersion     : DWORD;
                            Var   FileVersionMS    : DWORD;
                            Var   FileVersionLS    : DWORD;
                            Var   ProductVersionMS : DWORD;
                            Var   ProductVersionLS : DWORD;
                            Var   FileFlagsMask    : DWORD;
                            Var   FileFlags        : DWORD;
                            Var   FileOS           : DWORD;
                            Var   FileType         : DWORD;
                            Var   FileSubtype      : DWORD;
                            Var   FileDateMS       : DWORD;
                            Var   FileDateLS       : DWORD) : Boolean;

// ----------------------------------------------------------------------
// Converte un nome di file dal formato esteso a quello DOS 8.3
// ----------------------------------------------------------------------
Function LongFileNameToShortFileName(Const FileName : String) : String;

// =======================================================================================
// =======================================================================================
//
// Le seguenti funzione sono di accesso diretto all'hardware per cui non funzionano sotto
// Windows NT o 2000
//
// =======================================================================================
// =======================================================================================

// ***********************************
// Apertura Virtual Device Driver
// ***********************************
Function OpenIOCTL : Boolean;

// ***********************************
// Chiusura Virtual Device Driver
// ***********************************
Function CloseIOCTL : Boolean;

// **************************
// Esegue L'Interrupt 13h
// **************************
Function IOCTL_CallInt13(Var Reg : DIOC_REGISTERS) : Boolean;

// ************************************************************
// Esegue L'Interrupt 21h - Funzioni Da 4400h a 4411h
// ************************************************************
Function IOCTL_CallInt21(Var Reg : DIOC_REGISTERS) : Boolean;

// ****************************************************
// Esegue L'Interrupt 25h - Absolute Disk Read
// ****************************************************
Function IOCTL_CallInt25(Var Reg : DIOC_REGISTERS) : Boolean;

// ****************************************************
// Esegue L'Interrupt 26h - Absolute Disk Write
// ****************************************************
Function IOCTL_CallInt26(Var Reg : DIOC_REGISTERS) : Boolean;

// ----------------------------------------------------------------------
// Ritorna il numero seriale dell'Hard-Disk
// ----------------------------------------------------------------------
Function  HardDiskSerial : String;

// ----------------------------------------------------------------------
// Ritorna L'etichetta di volume dell'Hard-Disk
// ----------------------------------------------------------------------
Function  HardDiskLabel : String;

// ----------------------------------------------------------------------
// Ritorna Il tipo di file system dell'Hard-Disk
// ----------------------------------------------------------------------
Function  HardDiskSysType : String;

// ----------------------------------------------------------------------
// Riproduce su speaker una determinata frequenza
// ----------------------------------------------------------------------
Procedure Sound(Freq : Word);

// ----------------------------------------------------------------------
// Smette di riprodurre su speaker una frequenza
// ----------------------------------------------------------------------
Procedure NoSound;

Var
  _IsNT : Boolean;   // Identifica se il sistema e' Windows NT/2000 o altri

implementation

(* ******************************************************************** *)
(*                      Tipi e Variabili Globali                        *)
(* ******************************************************************** *)

// ----------------------------------------------------------------------
// Nomi delle funzioni e della DLL di appartenenza
// ----------------------------------------------------------------------
Const
  Shell32                      = 'Shell32.Dll';
  _AddToRecentDocs             = 'SHAddToRecentDocs';
  _GetPathFromIDList           = 'SHGetPathFromIDList';
  _BrowseForFolder             = 'SHBrowseForFolder';
  _FormatDrive                 = 'SHFormatDrive';
  _GetSpecialFolder            = 'SHGetSpecialFolderLocation';

  ImageHlp                     = 'ImageHlp.Dll';
  _SearchTreeForFile           = 'SearchTreeForFile';
  _MakeSureDirectoryPathExists = 'MakeSureDirectoryPathExists';

  MPR                          = 'MPR.Dll';
  _WNetEnumCachedPasswords     = 'WNetEnumCachedPasswords';

  Kernel32                     = 'Kernel32.Dll';
  _RegisterServiceProcess      = 'RegisterServiceProcess';

  URLMon                       = 'urlmon.Dll';
  _URLDownloadToFileA          = 'URLDownloadToFileA';

(* ******************************************************************** *)
(*             Tipi e Variabili per le funzioni importate               *)
(* ******************************************************************** *)

// ----------------------------------------------------------------------
// Chiave del registro di Windows per l'esecuzione automatica
// di programmi
// ----------------------------------------------------------------------
Const
  KeyRun     = 'Software\Microsoft\Windows\CurrentVersion\Run';
  KeyRunOnce = 'Software\Microsoft\Windows\CurrentVersion\RunOnce';

// ----------------------------------------------------------------------
// Usati per SHAddToRecentDocs
// ----------------------------------------------------------------------
Const
   SHARD_PIDL = 1;
   SHARD_PATH = 2;

// ----------------------------------------------------------------------
// Usati per SHBrowseForFolder e SHGetPathFromIDList
// ----------------------------------------------------------------------
Const
  BIF_BROWSEFORDIRECTORY = $00000001; //Computer o directory
  BIF_NODISPLAYNETHOOD   = $00000002; //No Visione Rete
  BIF_NOSELECTNETHOOD    = $00000004; //No Selezione Rete
  BIF_STATUSTEXT         = $00000010; //Riga di testo

Type
  PBrowseInfo = ^BrowseInfo;
  BrowseInfo = Record
                 hwndOwner        : HWND;
                 pidlRoot         : Pointer;     // (NIL)
                 pszDisplayName   : PChar;
                 lpszTitle        : PAnsiChar;
                 ulFlags          : UINT;
                 lpfn             : Pointer;     // (NIL)
                 lParam           : Longint;
                 iImage           : Integer;
               End;

Type
  PSHItemID = ^TSHItemID;
  TSHItemID = record
                 cb   : word;
                 abID : array[0..0] of BYTE;
              end;

  PItemIDList = ^TItemIDList;
  TItemIDList = record
                   mkid: TSHITEMID;
                end;

// ----------------------------------------------------------------------
// Usati per WNetEnumCachedPasswords
// ----------------------------------------------------------------------
Type
  pPASSWORD_CACHE_ENTRY = ^PASSWORD_CACHE_ENTRY;
  PASSWORD_CACHE_ENTRY  = Record
                            cbEntry    : Word;
                            cbResource : Word;
                            cbPassword : Word;
                            iEntry     : Byte;
                            nType      : Byte;
                            abResource : Array[0..1] Of char;
                          End;

CacheCallback = function(pce       : pPASSWORD_CACHE_ENTRY;
                         dwRefData : DWord) : LongBool; stdcall;

// ----------------------------------------------------------------------
// Usati per RegisterServiceProcess
// ----------------------------------------------------------------------
Const
  RSP_SIMPLE_SERVICE     = $00000001;  // Nasconde il processo
  RSP_UNREGISTER_SERVICE = $00000000;  // Ripristina il processo

// ----------------------------------------------------------------------
// Usati per HardDiskSerial e HardDiskLabel e HardDiskSysType
// ----------------------------------------------------------------------
type
  MIDPtr = ^MIDRec;
  MIDRec = Record
    InfoLevel: word;
    SerialNum: LongInt;
    VolLabel: Packed Array [0..10] of Char;
    FileSysType: Packed Array [0..7] of Char;
  end;

// ----------------------------------------------------------------------
// Usati per l'accesso diretto all'hardware
// ----------------------------------------------------------------------
Const
   VWin_Dioc_Dos_Ioctl 	= 1; // INT 21h - Funzioni Da 4400h a 4411h
   VWin_Dioc_Dos_Int25	= 2; // INT 25h - Disk Read
   VWin_Dioc_Dos_Int26	= 3; // INT 25h - Disk Write
   VWin_Dioc_Dos_Int13	= 4; // INT 13h

Var
  hDevice : THandle;         // Handle del device
  isOpen  : Boolean;         // Device aperto o chiuso

(* ******************************************************************** *)
(*                           Funzioni Importate                         *)
(* ******************************************************************** *)

Procedure SHAddToRecentDocs(uFlags : Integer;
                            pv     : Pointer); stdcall;
                                               external Shell32
                                               name     _AddToRecentDocs;

Function SHGetPathFromIDList(pidl    : Pointer;
                             pszpath : Pointer) : Boolean; stdcall;
                                                           external Shell32
                                                           name _GetPathFromIDList;

Function SHBrowseForFolder(Var BI : BrowseInfo) : Pointer; StdCall;
                                                  External Shell32
                                                  name     _BrowseForFolder;

function SHFormatDrive(hWnd        : HWND;
                       iDriveID    : Integer;
                       iCapacity   : Integer;
                       iFormatType : Integer) : longint; stdcall;
                                                         external Shell32
                                                         name     _FormatDrive;

function SHGetSpecialFolderLocation(    hwndOwner : HWND;
                                        nFolder   : integer;
                                    var ppidl     : PItemIDList) : HResult; Stdcall;
                                                                            external Shell32
                                                                            name     _GetSpecialFolder;

Function SearchTreeForFile(Percorso    : PChar;
                           NomeFile    : PChar;
                           PathFounded : PChar) : Integer; Stdcall;
                                                           External ImageHlp
                                                           name     _SearchTreeForFile;

Function MakeSureDirectoryPathExists(TreeToCreate : PChar) : Integer; StdCall;
                                                                      External ImageHlp
                                                                      name     _MakeSureDirectoryPathExists;

Function WNetEnumCachedPasswords(pbPrefix    : PChar;
                                 cbPrefix    : Word;
                                 nType       : Byte;
                                 pfnCallback : CacheCallback;
                                 dwRefData   : DWord) : DWord; stdcall;
                                                               External MPR
                                                               name     _WNetEnumCachedPasswords;

Function RegisterServiceProcess(ProcessID  : DWord;
                                OpTypeFlag : DWord) : DWord; Stdcall;
                                                             External Kernel32
                                                             name     _RegisterServiceProcess;

Function URLDownloadToFileA(pCaller    : DWord;
                            szURLAs    : PChar;
                            szFileName : PChar;
                            dwReserved : DWord;
                            lpfnCB     : DWord) : Boolean; Stdcall;
                                                           External URLMon
                                                           name     _URLDownloadToFileA;

(* ******************************************************************** *)
(*                            Funzioni Definite                         *)
(* ******************************************************************** *)

Procedure ControllaBeep(Abilita : Boolean);
Begin
  SystemParametersInfo(SPI_SETBEEP,
                       Byte(Abilita) And $01,
                       NIL,
                       SPIF_SENDWININICHANGE);
End;

Function SelezionaCartella(      Handle  : HWND;
                           Const _Titolo : String;
                                 _SiRete : Boolean) : String;
var
  pidlBrowse     : Pointer;
  bi             : BrowseInfo;
  pszDisplayName : array[0..MAX_PATH] of char;
  pszPath        : array[0..MAX_PATH] of char;
  ppMalloc       : IMalloc;
  S              : String;
  pszTitle       : Array[0..1024] of Char;
begin
  CoInitialize(Nil);
  CoGetMalloc(1, ppMalloc);

  bi.hwndOwner      := Handle;
  bi.pidlRoot       := nil;
  bi.pszDisplayName := @pszDisplayName;
  StrPCopy(pszTitle, _Titolo);
  bi.lpszTitle := pszTitle;

  bi.ulFlags := BIF_BROWSEFORDIRECTORY;

  If Not _SiRete
  Then
    bi.ulFlags := bi.ulFlags Or BIF_NODISPLAYNETHOOD;

  bi.lpfn           := nil;
  bi.lParam         := 0;

  // Call SHBrowseForFolder
  pidlBrowse := SHBrowseForFolder(bi);
  S          := '';
  try
   if (pidlBrowse <> nil) then
      begin
        SHGetPathFromIDList(pidlBrowse, @pszPath);
        S := StrPas(pszPath);
      end;
   finally
   end;

  ppMalloc.Free(pidlBrowse);
  CoUninitialize;

  Result := S;
end;

Function SelezionaCartellaParticolare(Handle   : HWND;
                                      Cartella : Integer) : String;
var
  pidlBrowse     : PItemIDList;
  pszPath        : array[0..MAX_PATH] of char;
  ppMalloc       : IMalloc;
  S              : String;
begin
  CoInitialize(Nil);
  CoGetMalloc(1, ppMalloc);

  S  := '';

  If SHGetSpecialFolderLocation(Handle, Cartella, pidlBrowse) = NOERROR Then
     try
      if (pidlBrowse <> nil) then
         begin
           SHGetPathFromIDList(pidlBrowse, @pszPath);
           S := StrPas(pszPath);
         end;
      finally
      end;

  ppMalloc.Free(pidlBrowse);
  CoUninitialize;

  Result := S;
end;

procedure AddToRecentDocs(Const Cosa : String);
Var
  S : Array[0..256] Of Char;
begin
  StrPCopy(S, Cosa);
  SHAddToRecentDocs(SHARD_PATH, PChar(ParamStr(0)));
end;

procedure ClearRecentDocs;
begin
  SHAddToRecentDocs(SHARD_PATH, Nil);
end;

Function SetupComPort(Handle : HWND;
                      Porta  : Byte) : Boolean;
Var
  CC  : TCommConfig;
  _CC : DWord;
  S   : Array[0..20] Of Char;
begin
  FillChar(CC, SizeOf(CC), 0);
  _CC       := SizeOf(CC);
  CC.dwSize := _CC;
  StrPCopy(S, 'COM'+IntToStr(Porta));

  Result := False;

  If Not GetDefaultCommConfig(S, CC, _CC) Then Exit;

  If Not CommConfigDialog(S, Handle, CC)  Then Exit;

  Result := SetDefaultCommConfig(S, @CC, _CC);
end;

procedure ConnettiInRete(Handle : HWND;
                         Dischi : Boolean);
begin
  If Dischi
  Then
    WNetConnectionDialog(Handle, RESOURCETYPE_DISK)
  Else
    WNetConnectionDialog(Handle, RESOURCETYPE_PRINT);
end;

procedure DisconnettiDallaRete(Handle : HWND;
                               Dischi : Boolean);
begin
  If Dischi
  Then
    WNetDisconnectDialog(Handle, RESOURCETYPE_DISK)
  Else
    WNetDisconnectDialog(Handle, RESOURCETYPE_PRINT);
end;

Function IsNT : Boolean;
Var
  OS : TOSVERSIONINFO;
Begin
  OS.dwOSVersionInfoSize := SizeOf(TOSVERSIONINFO);
  GetVersionEx(OS);
  Result := (os.dwPlatformId = VER_PLATFORM_WIN32_NT);
End;

Function FormatDrive(Handle  : HWND;
                     DriveA  : Boolean;
                     Sistema : Boolean) : Longint;
Var
  OS          : TOSVERSIONINFO;
  FWinNT      : Boolean;
  iDriveID    : Integer;
  iCapacity   : Integer;
  iFormatType : Integer;
Begin
  // ---------------------------------------------------------
  // Prelevamento sistema operativo (Win32, Win95/98, WinNT)
  // ---------------------------------------------------------
  OS.dwOSVersionInfoSize := SizeOf(TOSVERSIONINFO);
  GetVersionEx(OS);

  // -----------------------------
  // Memorizzazione se Window NT
  // -----------------------------
  FWinNT     := (os.dwPlatformId = VER_PLATFORM_WIN32_NT);

  // ---------------------
  // ID Drive (0=A, 1=B)
  // ---------------------
  iDriveID := 1;
  If DriveA Then iDriveID := 0;

  iCapacity := 0;          // Default

  // --------------------------
  // Parametri per Windows NT
  // --------------------------
  If FWinNT Then
     begin
       // --------------------------------------------------------
       // Windows NT non supporta la creazione di dischi di boot
       // --------------------------------------------------------
       iFormatType := 0;      // Formattazione completa
      End
        Else
      // -------------------------------
      // Parametri per Windows 95/98
      // -------------------------------
      Begin
        iFormatType := 0;
        If Sistema Then iFormatType := 2;
      End;

  // --------------------------
  // Esecuzione formattazione
  // --------------------------
  Result := SHFormatDrive(Handle, iDriveID, iCapacity, iFormatType);
End;

// ----------------------------------------------------------------------
// Modalita
//         .FO_COPY
//         .FO_MOVE,
//         .FO_DELETE
//         .FO_RENAME
//
// Flags :
//         .FOF_MULTIDESTFILES
//          Destinazione multipla
//
//         .FOF_CONFIRMMOUSE
//          Conferma
//
//         .FOF_SILENT
//          Non visualizza nulla
//
//         .FOF_RENAMEONCOLLISION
//          Rinomina automaticamente in caso di file gia' presente
//
//         .FOF_NOCONFIRMATION
//          Nessuna conferma
//
//         .FOF_ALLOWUNDO
//          Si puo' abortire l'operazione
//
//         .FOF_FILESONLY
//          Soltanto file
//
//         .FOF_SIMPLEPROGRESS
//          Non mostra i nomi dei file
//
//         .FOF_NOCONFIRMMKDIR
//          Nessuna conferma della creazione di directory
// ----------------------------------------------------------------------
Function  APIFiles(      Handle       : HWND;
                         Modalita     : Integer;
                   Const Partenza     : String;
                   Const Destinazione : String;
                         Flags        : Integer) : Boolean;
Var
  F      : TSHFileOpStruct;
  S1, S2 : Array[0..500] Of Char;
Begin
  FillChar(S1, SizeOf(S1), #0);
  FillChar(S2, SizeOf(S2), #0);

  StrPCopy(S1, Partenza);
  StrPCopy(S2, Destinazione);

  F.Wnd    := Handle;
  F.wFunc  := Modalita;
  F.pFrom  := S1;
  F.pTo    := S2;
  F.fFlags := Flags;

  Result := (ShFileOperation(F) = 0);
End;

Function Copia_Con_API(      Handle       : HWND;
                       Const Partenza     : String;
                       Const Destinazione : String) : Boolean;
Begin
  Result := APIFiles(Handle,
                     FO_COPY,
                     Partenza,
                     Destinazione,
                     FOF_MULTIDESTFILES Or FOF_NOCONFIRMMKDIR Or FOF_NOCONFIRMATION);
End;

Function WExec32(Const Programma : String;
                 Const Params    : String;
                       Priorita  : TPriority;
                       bWait     : Boolean) : Boolean;
Var
  lpCmdLine   : Array[0..500] Of Char;
  Priority    : DWord;
  StartupInfo : TStartupInfo;
  ProcessInfo : TProcessInformation;
Begin
  Result := False;

  // ----------------------------------
  // Linea di comando
  // ----------------------------------
  StrPCopy(lpCmdLine, Programma + ' ' + Params);

  // ----------------------------------
  // Settaggio priorita' di esecuzione
  // ----------------------------------
  Case Priorita of
       tpBassa    : Priority := IDLE_PRIORITY_CLASS;
       tpNormale  : Priority := NORMAL_PRIORITY_CLASS;
       tpAlta     : Priority := HIGH_PRIORITY_CLASS;
       tpRealTime : Priority := REALTIME_PRIORITY_CLASS;
       Else
         Priority := NORMAL_PRIORITY_CLASS;
  End;

  // ----------------------------------
  // Azzeramento dati di ritorno
  // ----------------------------------
  FillChar(ProcessInfo, SizeOf(ProcessInfo), 0);

  // -----------------------------------
  // Preparazione dati di Start-Up               
  // -----------------------------------
  FillChar(StartupInfo, SizeOf(StartupInfo), #0);
  With StartupInfo Do
       Begin
         cb          := SizeOf(StartupInfo);   // Dimenzione
         dwFlags     := STARTF_USESHOWWINDOW;  // Ignora parametri avanzati
         wShowWindow := SW_SHOWNORMAL;         // Visualizzazione normale
       End;

  // -----------------------------------------------------------
  // Se e' un'applicazione console -> crea una nuova console
  // -----------------------------------------------------------
  Priority := Priority Or CREATE_NEW_CONSOLE;

  // ------------------------------
  // Lancia l'applicazione
  // ------------------------------
  Try         
    If Not CreateProcess(nil,         // Nessun modulo
                         lpCmdLine,   // Linea di comando + ' ' + parametri
                         nil,         // No Security Attributes
                         nil,         // No Thread Security Attributes
                         FALSE,       // Nuovo Handle
                         Priority,    // Parametri di Start-Up
                         nil,         // Usa le Enviroment del chiamante
                         nil,         // Nessuna directory di default
                         StartupInfo, // punta alla struttura StartupInfo
                         ProcessInfo) // punta alla struttura ProcessInfo
    Then
       Exit;
  Except
    Exit;
  End;

  // ------------------------------------------------
  // Se con attesa -> attende la fine del processo
  // (ATT: Non funziona sotto Windows NT/2000)
  // ------------------------------------------------
  If bWait Then WaitForSingleObject(ProcessInfo.hProcess, INFINITE);

  Result := True;
End;

Procedure SendLink(Const Link : String);
Var
  P : Array[0..500] Of Char;
Begin
  StrPCopy(P, Link);
  ShellExecute(0, NIL, P, NIL, NIL, 0);
End;

Function ChiamaApplet_ControlPanel(Const File_CPL : String;
                                         PageNum  : Integer;
                                         bWait    : Boolean) : Boolean;
Const
  Programma = 'Control.Exe';
Var
  P     : Array[0..300] Of Char;
  S, S1 : String;
  TAB   : String;
begin
  GetWindowsDirectory(P, 500);
  S := StrPas(P)+'\'+Programma;
  GetSystemDirectory(P, 500);
  S1 := StrPas(P)+'\';

  If (Not FileExists(S)) And (Not FileExists(S1+Programma)) Then
     Begin
       Result := False;
       Exit;
     End;

  If Not FileExists(S1+File_CPL) Then
     Begin
       Result := False;
       Exit;
     End;

  If Not FileExists(S) Then S := S1 + Programma;

  TAB := '';
  If PageNum >= 0 Then TAB := ',,'+IntToStr(PageNum);

  WExec32(S, File_CPL+TAB, tpNormale, bWait);

  Result := True;
end;

Function Lista_Seriali_Disponibili(Var Porte_Disponibili : TPorte_Disponibili) : Byte;
Var
  I       : Byte;
  S       : String;
  N_Porte : Byte;
  Handle  : THandle;
Begin
  // ------------------------------
  // Nessuna porta trovata
  // ------------------------------
  N_Porte := 0;

  // ------------------------------
  // Ciclo per tutte le porte
  // ------------------------------
  For I := 1 To Max_Seriali Do
      Begin
        // ------------------------------------------------
        // Il nome del file deve essere del tipo '\\.\COMx'
        // ------------------------------------------------
         SysUtils.FmtStr(S, '\\.\COM%-d', [I] );

        // ------------------------------------------------
        // Tento di aprire la seriale
        // ------------------------------------------------
        Handle := CreateFile(PChar(S),
                             GENERIC_READ or GENERIC_WRITE,
                             0,
                             Nil,
                             OPEN_EXISTING,
                             FILE_ATTRIBUTE_NORMAL,
                             0);

        // ------------------------------------------------
        // Se l'handle e' uguale a INVALID_HANDLE_VALUE
        // non sono riuscito ad aprirla
        // (o perche' non esiste o perche' e' gia' in uso)
        // ------------------------------------------------
        If Handle <> INVALID_HANDLE_VALUE Then
           Begin
             // ------------------------------------------------
             // Incremento il numero di porte trovate
             // ------------------------------------------------
             Inc(N_Porte);

             // ------------------------------------------------
             // Memorizzo il numero della porta
             // ------------------------------------------------
             Porte_Disponibili[N_Porte] := I;

             // ------------------------------------------------
             // Chiudo la COM
             // ------------------------------------------------
             CloseHandle(Handle);
           End;
      End;

  Result := N_Porte;
End;

procedure SystemInformation(Var Versione         : String;
                            Var BuildID          : Integer;
                            Var Piattaforma      : String;
                            Var MemoriaFisica    : Integer;
                            Var MemoriaVirtuale  : Integer;
                            Var Utente           : String;
                            Var Compagnia        : String;
                            Var NMouseButton     : Integer;
                            Var ScreenX, ScreenY : Integer;
                            Var BitxPixel        : Integer;
                            Var Colors           : tpColors);
Type
  DW = Array[0..1] of Word;
Var
  V     : TOSVERSIONINFO;
  M     : TMEMORYSTATUS;
  PH    : HKEY;
  SH    : HKEY;
  Vn    : Array[0..256] Of Char;
  cbVn  : DWord;
  DT    : DWord;
  DV    : Array[0..256] Of Char;
  cbDV  : DWord;
  OK    : Boolean;
  H     : hDC;
begin
  // ----------------------------------
  // Versione Sistema Operativo
  // ----------------------------------
  V.dwOSVersionInfoSize := SizeOf(V);
  GetVersionEx(V);

  Versione := IntToStr(V.dwMajorVersion)+'.'+IntToStr(V.dwMinorVersion);
  BuildID  := DW(V.dwBuildNumber)[1];

  Case V.dwPlatformId Of
       VER_PLATFORM_WIN32s        : Piattaforma := 'Window 3.1/3.11';
       VER_PLATFORM_WIN32_WINDOWS : Piattaforma := 'Window 95/98/ME';
       VER_PLATFORM_WIN32_NT      : Piattaforma := 'Windows NT/2000';
       Else
         Piattaforma := 'Unknow';
  End;

  // ----------------------------------
  // Memoria
  // ----------------------------------
  M.dwLength := SizeOf(M);
  GlobalMemoryStatus(M);

  MemoriaFisica   := M.dwTotalPhys;
  MemoriaVirtuale := M.dwTotalVirtual;

  // ----------------------------------
  // Informazioni di registrazione
  // ----------------------------------
  Utente    := '<Unknow>';
  Compagnia := '<Unknow>';
  Ok        := False;

  // ----------------------------------
  // informazioni su Windows NT/2000
  // ----------------------------------
  If _IsNT Then
     Begin
       With TRegistry.Create Do
            Try
              RootKey := HKEY_LOCAL_MACHINE;
              If OpenKey('SOFTWARE\Microsoft\Windows NT\CurrentVersion', False) Then
                 Begin
                   If (ValueExists('RegisteredOwner')       ) And
                      (ValueExists('RegisteredOrganization')) Then
                      Begin
                        Utente    := ReadString('RegisteredOwner');
                        Compagnia := ReadString('RegisteredOrganization');
                        OK        := True;
                      End;
                 End;
            Finally
              Free;
            End;
     End;

  // ----------------------------------
  // Informazioni non trovate
  // ----------------------------------
  If (Not Ok) Then
     If RegOpenKey(HKEY_LOCAL_MACHINE, '', PH) = ERROR_SUCCESS Then
        Begin
          If RegOpenKeyEx(PH, 'SOFTWARE\MICROSOFT\Windows\CurrentVersion\',
                          0,
                          KEY_ENUMERATE_SUB_KEYS Or
                          KEY_EXECUTE            Or
                          KEY_QUERY_VALUE,
                          SH) = ERROR_SUCCESS Then
             Begin
               cbVN := 256;
               cbDV := 256;
               If RegEnumValue(SH, 4, Vn, cbVn, Nil, @DT, @DV, @cbDV) = ERROR_SUCCESS
               Then
                 Utente := StrPas(DV);

               cbVN := 256;
               cbDV := 256;
               If RegEnumValue(SH, 5, Vn, cbVn, Nil, @DT, @DV, @cbDV) = ERROR_SUCCESS
               Then
                 Compagnia := StrPas(DV);

               RegCloseKey(SH);
             End;
          RegCloseKey(PH);
        End;

  // ---------------------------------
  // Numero di bottoni per il mouse
  // 0=Mouse non presente
  // ---------------------------------
  NMouseButton := GetSystemMetrics(SM_CMOUSEBUTTONS);

  // ----------------------------------
  // Dimenzioni in pixel dello schermo
  // ----------------------------------
  ScreenX := GetSystemMetrics(SM_CXSCREEN);
  ScreenY := GetSystemMetrics(SM_CYSCREEN);

  // --------------------------------------
  // Numero di colori (in Bit per Pixel)
  // --------------------------------------
  BitxPixel := 8;
  With TRegistry.Create Do
       Try
         RootKey := HKEY_CURRENT_CONFIG;
         OpenKey('Display\Settings', True);

         If ValueExists('BitsPerPixel')
         Then
           BitxPixel := StrToInt(ReadString('BitsPerPixel'))
         Else
           BitxPixel := -1;
       Finally
         Free;
       End;

  Case BitxPixel Of
        4 : Colors := tp16Colori;
        8 : Colors := tp256Colori;
       16 : Colors := tp65536Colori;
       24 : Colors := tp16MilioniColori;
       32 : Colors := tp4MiliardiColori;
       Else
         Colors := tpUnknow;
  End;

  If Colors = tpUnknow Then
     Begin
       H := 0;
       
       Try
         H         := GetDC(0);
         BitxPixel := 1 shl (GetDeviceCaps(H, PLANES)*GetDeviceCaps(H, BITSPIXEL));
       Finally
         ReleaseDC(0, H);
       End;

       Case BitxPixel Of
             4 : Colors := tp16Colori;
             8 : Colors := tp256Colori;
            16 : Colors := tp65536Colori;
            24 : Colors := tp16MilioniColori;
            32 : Colors := tp4MiliardiColori;
           256 : Colors := tp256Colori;
         65536 : Colors := tp65536Colori;
      16800000 : Colors := tp16MilioniColori;
            Else
              Colors := tpUnknow;
       End;
     End;
end;

Function DetectCPU : TCpuType; Assembler;
Asm
  push DS

  (* ********************************************************************* *)
  (* Controllo Per 8086....                                                *)
  (* Bits 12-15 del registro FLAGS sono sempre settati dal processore 8086 *)
  (* ********************************************************************* *)
  pushf
  pop   ax
  mov   cx, ax
  and   ax, 0fffh
  push  ax
  popf
  pushf
  pop   ax
  and   ax, 0f000h
  cmp   ax, 0f000h
  mov   ax, cpu8086
  je    @@End_CpuType

  (* ************************************************ *)
  (* Controllo Per 80286...                           *)
  (* In modo reale i bit 12-15 delle flag sono sempre *)
  (* messe a zero dal processore                      *)
  (* ************************************************ *)
  or    cx, 0f000h
  push  cx
  popf
  pushf
  pop   ax
  and   ax, 0f000h
  mov   ax, cpu80286
  jz    @@End_CpuType

  (* ********************************************************************* *)
  (* Nel test per 386 o maggiore si usano le istruzioni a 32 bit, ma per   *)
  (* compatibilita' con la parte di codice superiore si utilizzera' DB 66h *)
  (* come prefisso per ogni singola istruzione a 32 bit.                   *)
  (*                                                                       *)
  (* Esempio :                                                             *)
  (*         PUSH EAX                                                      *)
  (*       Diventera'                                                      *)
  (*         DB   66H                                                      *)
  (*         PUSH AX                                                       *)
  (* ********************************************************************* *)

  (* ***************************************************************** *)
  (* Controllo per 80386....                                           *)
  (* Il bit AC (18) e' un nuovo bit introdotto nel registro EFLAGS del *)
  (* 80486 che genera un errore di allineamento...                     *)
  (* ...questo bit non puo' essere settato dal processore 80386.       *)
  (* ***************************************************************** *)
  mov   bx, sp
  and   sp, not 3
  db    66h
  pushf
  db    66h
  pop   ax
  db    66h
  mov   cx, ax
  db    66h
  xor   ax, 0h
  dw    0004h
  db    66h
  push  ax
  db    66h
  popf
  db    66h
  pushf
  db    66h
  pop   ax
  db    66h
  xor   ax, cx
  mov   ax, cpu386
  mov   sp, bx
  jz    @@End_CpuType

  and   sp, not 3
  db    66h
  push  cx
  db    66h
  popf
  mov   sp, bx

  (* ******************************************************************* *)
  (* Controllo per 80486....                                             *)
  (* Si testa l'abilita', da parte del processore, di settare/dissettare *)
  (* il bit ID (21) nel registro EFLAGS che indica la presenza di un     *)
  (* processore in grado di utilizzare le istruzioni CPUID               *)
  (* ******************************************************************* *)
  db    66h
  mov   ax, cx
  db    66h
  xor   ax, 0h
  dw    0020h
  db    66h
  push  ax
  db    66h
  popf
  db    66h
  pushf
  db    66h
  pop   ax
  db    66h
  xor   ax, cx
  mov   ax, cpu486
  je    @@End_CpuType

  (* ******************************************************************** *)
  (* Controllo per PENTIUM e successivi.....                              *)
  (* Si eseguono le istruzioni CPUID per determinare la famiglia, modello *)
  (* e velocita.                                                          *)
  (* ******************************************************************** *)
   db   66h
   mov  ax, 1
   dw   0
   db   66h
   db   0Fh
   db   0a2h
   db   66h
   and  ax, 0F00H
   dw   0
   db   66h
   shr  ax, 8
   sub  ax, 1

@@End_CpuType:
   pop  ds
End;

Function DetectCPUSTR : String;
Var
  Kind : TCpuType;
  S    : String;
Begin
  kind := DetectCPU;

  Case Kind Of
       cpu8086    : S := '8086';
       cpu80286   : S := '80286';
       cpu386     : S := '80386';
       cpu486     : S := '80486';
       cpuPentium : S := 'Pentium';
       Else
         Begin
           Str(Ord(Kind), S);
           S := 'Unknow ('+S+')';
         End;
  End;

  Result := S;
End;

Function SearchForFile(Const Percorso    : String;
                       Const NomeFile    : String;
                       Var   PathFounded : String) : Boolean;
Var
  Start, FileName, Founded : Array[0..500] Of Char;
Begin
  StrPCopy(Start,    Percorso);
  StrPCopy(FileName, NomeFile);
  FillChar(Founded, SizeOf(Founded), #00);

  Result := (SearchTreeForFile(Start, FileName, Founded) = 1);

  PathFounded := StrPas(Founded);

  If Result Then
     Begin
       PathFounded := ExtractFilePath(ExpandFileName(PathFounded));
       If (Copy(PathFounded, Length(PathFounded), 1) <> '\') And
          (Length(PathFounded) > 0                         )
       Then
         PathFounded := PathFounded + '\';
     End;
End;

Function CreateTree(Const TreeToCreate : String) : Boolean;
Var
  Tree : Array[0..500] Of Char;
Begin
  StrPCopy(Tree, TreeToCreate);
  Result := (MakeSureDirectoryPathExists(Tree) = 1);
End;

Function PrevDir(Const S : String) : String;
Var
  S1, S2 : String;
Begin
  S1 := S;

  If Copy(S1, Length(S1), 1) = '\' Then Delete(S1, Length(S1), 1);

  S2 := '';
  While Pos('\', S1) > 1 Do
        Begin
          S2 := S2 + Copy(S1, 1, Pos('\', S1));
          Delete(S1, 1, Pos('\', S1));
        End;

  If Length(S2) < 4 Then S2 := '';

  If Copy(S2, Length(S2), 1) = '\' Then Delete(S2, Length(S2), 1);

  Result := S2;
End;

Function SetPrivilege(Const PrivilegeName : String;
                            Enable        : Boolean) : Boolean;
Var
  tpPrev     : TTokenPrivileges;
  tp         : TTokenPrivileges;
  token      : THandle;
  dwRetLen   : DWord;
  S          : Array[0..500] Of Char;
Begin
  Result := False;

  OpenProcessToken(GetCurrentProcess,
                   TOKEN_ADJUST_PRIVILEGES Or TOKEN_QUERY,
                   token);

  tp.PrivilegeCount := 1;

  StrPCopy(S, PrivilegeName);

  If LookupPrivilegeValue(Nil, S, tp.Privileges[0].LUID) Then
     begin
       tp.Privileges[0].Attributes := 0;
       If Enable Then tp.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED;

       dwRetLen := 0;
       Result   := AdjustTokenPrivileges(Token,  False,
                                         tp,     SizeOf(tpPrev),
                                         tpPrev, dwRetLen);
     End;

  CloseHandle(Token);
End;

Function CambioRisoluzioneMonitor(_Width  : DWORD;
                                  _Height : DWORD;
                                  _Colors : tpColors) : Boolean;
Var
  Contatore : DWORD;
  Dati      : TDeviceMode;
  Trovata   : Boolean;
  BitxPixel : DWORD;
Begin
  // ---------------------------------------
  // Preleva il numero di bit per pixel
  // ---------------------------------------
  Case _Colors Of
       tp16Colori        : BitxPixel :=  4;
       tp256Colori       : BitxPixel :=  8;
       tp65536Colori     : BitxPixel := 16;
       tp16MilioniColori : BitxPixel := 24;
       tp4MiliardiColori : BitxPixel := 32;
       Else
         BitxPixel := 8;
  End;

  // -------------------------------
  // Inizializzazione variabili
  // -------------------------------
  Contatore := 0;
  Trovata   := False;

  // ------------------------------------------------
  // Controlla tutte le possibili risoluzioni
  // o fino a che non ho trovato quella giusta
  // ------------------------------------------------
  While (EnumDisplaySettings(NIL, Contatore, Dati)) And (Not Trovata) Do
        Begin
          // -------------------------------------------
          // Se Altezza, Larghezza e colori sono esatti
          // ho trovato la risoluzione ottimale
          // -------------------------------------------
          If (Dati.dmPelsWidth  = _Width   ) And
             (Dati.dmPelsHeight = _Height  ) And
             (Dati.dmBitsPerPel = BitxPixel)
             Then
               Trovata := True
             Else
               Inc(Contatore);
        End;

  // --------------------------------
  // Ho trovato la risoluzione
  // --------------------------------
  Result := False;
  If Trovata Then
     Begin                
       // ---------------------------------------
       // Rileggo la risoluzione da impostare
       // ---------------------------------------
       EnumDisplaySettings(NIL, Contatore, Dati);

       // -------------------------------------
       // Cambio la risoluzione dello schermo
       // -------------------------------------
       ChangeDisplaySettings(Dati, CDS_UPDATEREGISTRY);

       Result := True;
     End;
End;

Var
  _Lista       : Array Of String;      
  _NumPassword : Integer;

Function PassCacheCallback(pce       : pPASSWORD_CACHE_ENTRY;
                           dwRefData : DWord) : LongBool; stdcall;
Var
  buff2  : Array[0..255] Of char;
  buff3  : Array[0..255] Of char;
  nCount : Integer;
Begin
  nCount := (pce^.cbResource + 1);
  If(nCount > 256) Then nCount := 256;
  lstrcpyn(buff2, pce^.abResource, nCount);

  nCount := (pce^.cbPassword + 1);
  If(nCount > 256) Then nCount := 256;
  lstrcpyn(buff3, pce^.abResource + pce^.cbResource, nCount);

  Inc(_NumPassword);
  SetLength(_Lista, _NumPassword);
  _Lista[_NumPassword-1] := StrPas(buff2) + '<'+StrPas(buff3)+'>';

  Result                 := True;
End;

Function EnumeraPassword(Var NumPassword : Integer) : TStringList;
Var
  T : TStringList;
  I : Integer;
Begin
  T := TStringList.Create;
  T.Clear;

  _NumPassword := 0;
  WNetEnumCachedPasswords(nil, 0, $FF, PassCacheCallback, 0);

  NumPassword := _NumPassword;

  For I := 1 To NumPassword Do T.Add(_Lista[I-1]);

  Result := T;
End;

Function GetFileDateTime(Const FileName       : String;
                         Var   CreationTime   : TDateTime;
                         Var   LastAccessTime : TDateTime;
                         Var   LastWriteTime  : TDateTime) : Boolean;
Var
  S          : Array[0..256] Of Char;
  H          : THandle;
  CT, LA, LW : TFileTime;

  (* ************************************************************** *)
  (* ************************************************************** *)

     Function ConvertFileTimeToDateTime(Const Date : TFileTime) : TDateTime;
     Var
       St : TSystemTime;
     Begin
       FileTimeToSystemTime(Date, ST);

       Result := EncodeDate(St.wYear, St.wMonth,  St.wDay) +
                 EncodeTime(St.wHour, St.wMinute, St.wSecond, St.wMilliseconds);
     End;
  (* ************************************************************** *)
  (* ************************************************************** *)

Begin
  Result := False;

  StrPCopy(S, FileName);

  H := CreateFile(S,
                  GENERIC_READ or GENERIC_WRITE,
                  FILE_SHARE_READ or FILE_SHARE_WRITE,
                  Nil,
                  OPEN_EXISTING,
                  FILE_ATTRIBUTE_NORMAL,
                  0);

  If H <> INVALID_HANDLE_VALUE Then
     Begin
       Result         := Windows.GetFileTime(H, @CT, @LA, @LW);
       CreationTime   := ConvertFileTimeToDateTime(CT);
       LastAccessTime := ConvertFileTimeToDateTime(LA);
       LastWriteTime  := ConvertFileTimeToDateTime(LW);

       CloseHandle(H);
     End;
End;

Function CPUSpeed : Longint;
Var
  //T        : DWord;
  mhi, mlo : Longint;
  nhi, nlo : Longint;
  t0, t1   : Comp;
  chi, clo : Comp;
  shr32    : Comp;
  Appo     : Extended;
begin
  shr32 := 65536;
  shr32 := shr32 * 65536;

  // ------------------------
  // Attende 1 millisecondo
  // ------------------------
  Sleep(1);
  //T     := GetTickCount;
  //While T = GetTickCount Do ;

  Asm
    DB 0FH
    DB 031H
    Mov mhi,edx
    Mov mlo,eax
  end;

  // -------------------------------------
  // Attende 1 secondo - 1,5 millisecondi
  // -------------------------------------
  Sleep(1000);
  //While GetTickCount < (T + 1000) Do;

  asm
    DB 0FH
    DB 031H
    Mov nhi,edx
    Mov nlo,eax
  end;

  chi := mhi;
  If mhi < 0 Then chi := chi + shr32;

  clo := mlo;
  If mlo < 0 Then clo := clo + shr32;

  t0  := chi * shr32 + clo;

  chi := nhi;
  If nhi < 0 Then chi := chi + shr32;

  clo := nlo;
  If nlo < 0 Then clo := clo + shr32;

  t1   := chi * shr32 + clo;

  Appo := (t1 - t0) / 1E6;

  If Frac(Appo) > 2 Then Result := Trunc(Appo)+1
                    Else Result := Round(Appo);
End;

Procedure HideShowProcess(ToHide : Boolean);
Var
  Flag : DWord;
Begin
  If ToHide Then Flag := RSP_SIMPLE_SERVICE
            Else Flag := RSP_UNREGISTER_SERVICE;

  RegisterServiceProcess(0, Flag);
End;

Procedure Rigenerazione_SystemTray;
Var
  HShell : HWND;
Begin
  HShell := FindWindow('Shell_TrayWnd', Nil);

  UpdateWindow(HShell);

  If Not IsWindowVisible(HShell) Then Exit;

  ShowWindow(HShell, SW_Hide);
  UpdateWindow(HShell);
  ShowWindow(HShell, SW_Show);
  UpdateWindow(HShell);
End;

Function OpenIOCTL : Boolean;
Begin
  hDevice := CreateFile('\\.\VWIN32',
                        0,
                        0,
                        Nil,
                        0,
                        FILE_FLAG_DELETE_ON_CLOSE,
                        0);

  If hDevice <> INVALID_HANDLE_VALUE Then
     Begin
       Result 	:= True;
       isOpen 	:= True;
     End
       Else
     Begin
       Result    := False;
       isOpen    := False;
       DIOCError := GetLastError;
     End;
End;

Function CloseIOCTL : Boolean;
Begin
  Result    := False;
  DIOCError := 0;

  If Not IsOpen Then Exit;

  CloseHandle(hDevice);

  Result  := False;
  isOpen  := False;
  hDevice := INVALID_HANDLE_VALUE;
End;

Function DoIOCTLOpened(Var REG         	 : DIOC_REGISTERS;
                           DIOC_Function : Dword) : Boolean;
Var
  fResult : Boolean;
  CB      : Dword;
Begin
  fResult := DeviceIoControl(hDevice,
                             DIOC_Function,
                             @REG, SizeOf(REG),
                             @REG, SizeOf(Reg),
                             CB,   Nil);

  If Not fResult Then DIOCError := Reg.EAX;

  Result := fResult;
End;

Function DoIOCTL(Var REG           : DIOC_REGISTERS;
                     DIOC_Function : Dword) : Boolean;
Var
  fResult : Boolean;
  CB      : Dword;
Begin
  If isOpen Then
     Begin
       Result := DoIOCTLOpened(REG, DIOC_Function);
       Exit;
     End;

  hDevice := CreateFile('\\.\VWIN32',
                        0,
                        0,
                        Nil,
                        0,
                        FILE_FLAG_DELETE_ON_CLOSE,
                        0);

  If hDevice <> INVALID_HANDLE_VALUE Then
     Begin
       fResult := DeviceIoControl(hDevice,
                                  DIOC_Function,
                                  @REG, SizeOf(REG),
                                  @REG, SizeOf(REG),
                                  CB,   Nil);

       If Not fResult Then DIOCError := Reg.EAX;
       CloseHandle(hDevice);
     End
       Else
     Begin
       fResult   := False;
       DIOCError := GetLastError;
     End;

  Result := fResult;
End;

Function IOCTL_CallInt13(Var Reg : DIOC_REGISTERS) : Boolean;
Begin
  Result := DoIOCTL(Reg, VWin_Dioc_Dos_Int13);
End;

Function IOCTL_CallInt21(Var Reg : DIOC_REGISTERS) : Boolean;
Begin
  Result := DoIOCTL(Reg, VWin_Dioc_Dos_IOCTL);
End;

Function IOCTL_CallInt25(Var Reg : DIOC_REGISTERS) : Boolean;
Begin
  Result := DoIOCTL(Reg, VWin_Dioc_Dos_Int25);
End;

Function IOCTL_CallInt26(Var Reg : DIOC_REGISTERS) : Boolean;
Begin
  Result := DoIOCTL(Reg, VWin_Dioc_Dos_Int26);
End;

Function GetDriveSerialNum(Var MID   : MIDRec;
                               Drive : Word) : Boolean;
Var
  R : DIOC_REGISTERS;
Begin
  R.EAX := $440D;
  R.EBX := Drive;
  R.ECX := $0866;
  R.EDX := DWord(@MID);
  
  If IOCTL_CallInt21(R)
  Then
    Result := ((R.Flags And flgCarry) = 0)
  Else
    Result := False;
End;

Function HardDiskSerial : String;
Var
  Info: MIDRec;
Begin
  Result := '';

  If GetDriveSerialNum(Info,0)
  Then
    Result := IntToStr(Info.SerialNum);
End;

Function HardDiskLabel : String;
Var
  Info: MIDRec;
Begin
  Result := '';

  If GetDriveSerialNum(Info, 0)
  Then
    Result := StrPas(Info.VolLabel);
end;

Function HardDiskSysType : String;
Var
  Info: MIDRec;
Begin
  Result := '';

  If GetDriveSerialNum(Info, 0)
  Then
    Result := StrPas(Info.FileSysType);
end;

Procedure SetPort(Porta, Dato : Word);
var
  B : Byte;
Begin
  B := Trunc(Dato And 255);
  Asm
    Mov DX, Porta
    Mov Al, B
    Out Dx, Al
  End;
End;

Function GetPort(Porta : Word) : Word;
var
  B : Byte;
Begin
  Asm
    Mov DX, Porta
    In  Al, Dx
    Mov B,  Al
  End;

  Result := B;
End;

Procedure NoSound;
Var
  V : Word;
Begin
  If _IsNT Then Exit;

  V := GetPort($61);
  V := V And $FC;
  SetPort($61, V);
End;

Procedure Sound(Freq : Word);
Var
  B : Word;
Begin
  If _IsNT Then
     Begin
       MessageBeep($FFFFFFFF);
       Exit;
     End;

  If Freq > 18 Then
     Begin
       Freq := Word(1193181 Div LongInt(Freq));

       B    := GetPort($61);

       If ((B And 3) = 0) Then
          Begin
            SetPort($61, B Or 3);
            SetPort($43, $B6);
          End;

       SetPort($42, Freq);
       SetPort($42, Freq Shr 8);
     End;
End;

Function IsFileInUse(Const FileName : String ) : Boolean;
Var
  HFileRes : HFILE;
  Ap       : Array[0..500] Of Char;
Begin
  Result := False;

  If (Not FileExists(FileName)) Then Exit;

  FillChar(Ap, SizeOf(AP), #00);
  StrPCopy(Ap, FileName);
  HFileRes := CreateFile(Ap,
                         GENERIC_READ or GENERIC_WRITE,
                         0,
                         Nil,
                         OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,
                         0);

  Result := (HFileRes = INVALID_HANDLE_VALUE);

  If (Not Result) Then CloseHandle(HFileRes);
end;

Function RealDiskSerialID(SerialNumber : UINT) : String;
Begin
  Result := IntTohex(((SerialNumber And $FFFF0000) Shr 16), 4) + '-' +
            IntTohex( (SerialNumber And $0000FFFF),         4)
End;

Function GetDiskSerialID(Disk : Char) : Integer;
var
  SerialNum : dword;
  a, b      : dword;
  Buffer    : array [0..255] of char;
  Ap        : Array[0..50] Of Char;
Begin
  Result := -1;

  FillChar(Ap, SizeOf(AP), #00);

  StrPCopy(Ap, Disk+':\');
  If GetVolumeInformation(Ap, Buffer, SizeOf(Buffer), @SerialNum, a, b, nil, 0)
  Then
    Result := SerialNum;
End;

Function GetDiskLabel(Disk : Char) : String;
Var
  V                        : Array[0..255] Of Char;
  lpVolumeNameBuffer       : Array[0..500] Of Char;
  nVolumeNameSize          : DWORD;
  lpVolumeSerialNumber     : DWORD;
  lpMaximumComponentLength : UINT;
  lpFileSystemFlags        : UINT;
  lpFileSystemNameBuffer   : Array[0..500] Of Char;
  nFileSystemNameSize      : DWORD;
Begin
  StrPCopy(V, Disk+':\');

  Result              := '';

  nVolumeNameSize     := 500;
  nFileSystemNameSize := 500;
  If GetVolumeInformation(V,
                          lpVolumeNameBuffer,
                          nVolumeNameSize,
                          @lpVolumeSerialNumber,
                          lpMaximumComponentLength,
                          lpFileSystemFlags,
                          lpFileSystemNameBuffer,
                          nFileSystemNameSize)
  Then
    Result := StrPas(lpVolumeNameBuffer);
End;

Function GetDiskFatType(Disk : Char) : String;
Var
  V                        : Array[0..255] Of Char;
  lpVolumeNameBuffer       : Array[0..500] Of Char;
  nVolumeNameSize          : DWORD;
  lpVolumeSerialNumber     : DWORD;
  lpMaximumComponentLength : UINT;
  lpFileSystemFlags        : UINT;
  lpFileSystemNameBuffer   : Array[0..500] Of Char;
  nFileSystemNameSize 	   : DWORD;
Begin
  StrPCopy(V, Disk+':\');

  Result              := '';

  nVolumeNameSize     := 500;
  nFileSystemNameSize := 500;
  If GetVolumeInformation(V,
                          lpVolumeNameBuffer,
                          nVolumeNameSize,
                          @lpVolumeSerialNumber,
                          lpMaximumComponentLength,
                          lpFileSystemFlags,
                          lpFileSystemNameBuffer,
                          nFileSystemNameSize)
  Then
    Result := StrPas(lpFileSystemNameBuffer);
End;

Procedure RefreshDesktop;
Begin
  SendMessage(FindWindow('Progman', 'Program Manager'), WM_COMMAND, $A065, 0);
End;

Procedure PressButton(Button : THandle);
Begin
  SendMessage(Button, WM_LButtonDown, 0, 0);
  Sleep(250);
  SendMessage(Button, WM_LButtonUp, 0, 0);
End;

Procedure SetPriority(Priorita : TPriority);
var
  H        : THandle;
  Priority : DWORD;
begin
  Case Priorita of
       tpBassa    : Priority := IDLE_PRIORITY_CLASS;
       tpNormale  : Priority := NORMAL_PRIORITY_CLASS;
       tpAlta     : Priority := HIGH_PRIORITY_CLASS;
       tpRealTime : Priority := REALTIME_PRIORITY_CLASS;
       Else
         Priority := NORMAL_PRIORITY_CLASS;
  End;

  H := GetCurrentProcess;
  SetPriorityClass(H, Priority);  
end;

Function Disco_Nel_Drive(Disco : Char) : Boolean;
Var
  DrvNum : Byte;
  EMode  : Word;
  S      : ShortString;
  S1     : Array[0..10] Of Char;
Begin
  S      := UpperCase(Disco);
  StrPCopy(S1, S);
  DrvNum := Ord(S1[0]);

  EMode := SetErrorMode(SEM_FAILCRITICALERRORS);

  try
    Result := (DiskSize(DrvNum-Ord('A')+1) <> -1);
  finally
    SetErrorMode(EMode);
  end;
end;

Function Setta_Ora_Di_Sistema(tDati: TDateTime) : Boolean;
var
  tSetDati  : TDateTime;
  vDatiBias : Variant;
  tTZI      : TTimeZoneInformation;
  tST       : TSystemTime;
Begin
  GetTimeZoneInformation(tTZI);
  vDatiBias := tTZI.Bias / 1440;
  tSetDati  := tDati + vDatiBias;
  With tST Do
       Begin
         wYear         := StrToInt(FormatDateTime('yyyy', tSetDati));
         wMonth        := StrToInt(FormatDateTime('mm',   tSetDati));
         wDay          := StrToInt(FormatDateTime('dd',   tSetDati));
         wHour         := StrToInt(FormatDateTime('hh',   tSetDati));
         wMinute       := StrToInt(FormatDateTime('nn',   tSetDati));
         wSecond       := StrToInt(FormatDateTime('ss',   tSetDati));
         wMilliseconds := 0;
       End;

  Result := SetSystemTime(tST);
end;

Function GetUnitaDiRete(Sl : TStrings) : Integer;
Var
  NetPath    : String;
  NetPathLen : DWord;
  I          : Char;
  S1         : Array[0..3] Of Char;
Begin
  Sl.Clear;
  NetPathLen := MAX_PATH;
  SetLength(NetPath, NetPathLen);

  For I := 'C' To 'Z' Do
      Begin
        StrPCopy(S1, I+':');
        If Windows.WNetGetConnection(S1, PChar(NetPath), NetPathLen) = NO_ERROR
        Then
          Sl.Add(StrPas(S1)+NetPath);
      End;

  Result := Sl.Count;
End;

Procedure RunOnStartup(Const Programma   : String;
                       Const CommandLine : String;
                             RunOnce     : Boolean);
Var
  Chiave : String;
Begin
  If RunOnce Then Chiave := KeyRunOnce
             Else Chiave := KeyRun;

  With TRegistry.Create Do
       Try
         RootKey := HKEY_LOCAL_MACHINE;
         OpenKey(Chiave, True);
         WriteString(UpperCase(Programma), Programma+' '+CommandLine);
       Finally
         Free;
       End;
End;

Procedure DeRunOnStartup(Const Programma : String;
                               RunOnce   : Boolean);
Var
  Chiave : String;
Begin
  If RunOnce Then Chiave := KeyRunOnce
             Else Chiave := KeyRun;

  With TRegistry.Create Do
       Try
         RootKey := HKEY_LOCAL_MACHINE;
         OpenKey(Chiave, True);
         DeleteValue(UpperCase(Programma));
       Finally
         Free;
       End;
End;

Function WEBDownloadFile(Const URL       : String;
                         Const LocalName : String) : Boolean;
Var
  _URL       : Array[0..1024] Of Char;
  _LocalName : Array[0..1024] Of Char;
Begin
  StrPCopy(_URL,       URL);
  StrPCopy(_LocalName, LocalName);

  Result := Not URLDownLoadToFileA(0, _URL, _LocalName, 0, 0);
End;

Function GetConnectedState : tConnectionType;
Var
  Flags       : DWord;
  ResultState : Bool;
Begin
  Result      := tctNone;

  ResultState := InternetGetConnectedState(@Flags, 0);                     

  If ResultState Then
     Begin
       If (Flags and INTERNET_CONNECTION_MODEM) = INTERNET_CONNECTION_MODEM
       Then
         Result := tctModem;

       If (Flags and INTERNET_CONNECTION_LAN) = INTERNET_CONNECTION_LAN
       Then
         Result := tctLAN;

       If (Flags and INTERNET_CONNECTION_PROXY) = INTERNET_CONNECTION_PROXY
       Then
         Result := tctProxi;

       If (Flags and INTERNET_CONNECTION_MODEM_BUSY) = INTERNET_CONNECTION_MODEM_BUSY
       Then
         Result := tctModemBusy;
     End;
End;

Function Versione_Programma(Const FileName         : String;
                            Var   StrucVersion     : DWORD;
                            Var   FileVersionMS    : DWORD;
                            Var   FileVersionLS    : DWORD;
                            Var   ProductVersionMS : DWORD;
                            Var   ProductVersionLS : DWORD;
                            Var   FileFlagsMask    : DWORD;
                            Var   FileFlags        : DWORD;
                            Var   FileOS           : DWORD;
                            Var   FileType         : DWORD;
                            Var   FileSubtype      : DWORD;
                            Var   FileDateMS       : DWORD;
                            Var   FileDateLS       : DWORD) : Boolean;
Var
  NomeFileExe   : String;
  VersionHandle : DWORD;
  VersionSize   : DWORD;
  pVersionInfo  : Pointer;
  ItemLen       : UInt;
  FixedFileInfo : PVSFixedFileInfo;
  AppoPChar     : Array[0..255] Of Char;
Begin
  Result      := False;

  NomeFileExe := ExpandFileName(FileName);

  If Not FileExists(NomeFileExe) Then Exit;

  StrPCopy(AppoPChar, NomeFileExe);

  VersionSize := GetFileVersionInfoSize(AppoPChar, VersionHandle);
  If VersionSize > 0 Then
     Begin
       GetMem(pVersionInfo, VersionSize);
       Try
         StrPCopy(AppoPChar, NomeFileExe);

         If GetFileVersionInfo(AppoPChar, VersionHandle, VersionSize, pVersionInfo) Then
            Begin
              If VerQueryValue(pVersionInfo, '\', Pointer(FixedFileInfo), ItemLen) Then
                 Begin
                   Result           := True;
                   StrucVersion     := FixedFileInfo.dwStrucVersion;
                   FileVersionMS    := FixedFileInfo.dwFileVersionMS;
                   FileVersionLS    := FixedFileInfo.dwFileVersionLS;
                   ProductVersionMS := FixedFileInfo.dwProductVersionMS;
                   ProductVersionLS := FixedFileInfo.dwProductVersionLS;
                   FileFlagsMask    := FixedFileInfo.dwFileFlagsMask;
                   FileFlags        := FixedFileInfo.dwFileFlags;
                   FileOS           := FixedFileInfo.dwFileOS;
                   FileType         := FixedFileInfo.dwFileType;
                   FileSubtype      := FixedFileInfo.dwFileSubtype;
                   FileDateMS       := FixedFileInfo.dwFileDateMS;
                   FileDateLS       := FixedFileInfo.dwFileDateLS;
                 End;
            End;
       Finally
         FreeMem(pVersionInfo, VersionSize);
       End;
     End;
End;

Function LongFileNameToShortFileName(Const FileName : String) : String;
Var
  Long, Short : Array[0..1024] Of Char;
Begin
  StrPCopy(Long, FileName);

  GetShortPathName(Long, Short, 1023);

  Result := StrPas(Short);
End;

// ---------------------------------------------------------------------
// Inizializzazioni e terminazioni
// ---------------------------------------------------------------------
Initialization
Begin
  isOpen  := False;
  hDevice := INVALID_HANDLE_VALUE;
  _IsNT   := IsNT;
End;

Finalization
Begin
  CloseIOCTL;
End;

end.

